<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */


class Permission {

	private $Project;
	private	$rolesettings = array();
	private $Role;
	private $User = null;

	function __construct($Project, $User = null) {
		$this->Project = $Project;

		//RolePeer - get RoleSetting array
		$sess = Session::getSession();
		
		if (is_null($User)) {
			// Use the session user by default
			$this->User = $sess->getUser();
		} else {
			$this->User = $User;
		}

		if (is_null($this->User)) {
			// $this->User may be null if for example we're running with cronjob privileges
			return;
		}
		$user_id = $this->User->getUserId();

		if ($this->Project->getParentProjectId() > 0) {
			$projectsql=" IN (".$this->Project->getRootPath().")";
		} else {
			$projectsql="='".$this->Project->getProjectId()."'";
		}
		$sql = "SELECT role_setting.section,role_setting.ref_id,max(value) AS value FROM role_setting
			NATURAL JOIN user_project_role NATURAL JOIN user_project
			WHERE section=role_setting.section AND ref_id=role_setting.ref_id 
			AND (user_project.user_id='$user_id' OR user_project.user_id IN 
				(SELECT usergroup_id FROM usergroup_user WHERE member_user_id='$user_id'))
			AND user_project.project_id $projectsql
			GROUP BY section,ref_id";
		$rs = Propel::getConnection()->createStatement()->executeQuery($sql);

		while ($rs->next()) {
			$this->rolesettings[$rs->getString('section')][$rs->getInt('ref_id')]=$rs->getInt('value');
		}
	}

	function getRole() {
		return $this->Role;
	}

	function check ($section, $ref_id, $level) {
		// If the user is null, it means we're referring to the session user
		if (is_null($this->User)) {
			$sess = Session::getSession();
			if (!$sess->isLoggedIn()) {
				return false;
			}
		}

		if ($this->isAdmin()) {
			return true;
		} else {
			if (!isset($this->rolesettings[$section][$ref_id])) {
				return false;
			} else {
				if ($this->rolesettings[$section][$ref_id] >= $level) {
					return true;
				} else {
					return false;
				}
			}
		}
	}

	/**
	 * User is administrator for this project?
	 * @return	bool
	 */
	public function isAdmin() {
		if (is_null($this->User)) {
			// If the user is null, it means we're referring to the session user
			// (usually means this is running like a cronjob, so the line below
			// would return true)
			return Session::getSession()->isSiteAdmin();
		}

		if ($this->User->isSiteAdmin()) {
			return true;
		} else {
			if (isset($this->rolesettings['projectadmin'][0]) && $this->rolesettings['projectadmin'][0] == Project::PROJECT_ROLE_ADMIN) {
				return true;
			} else {
				return false;
			}
		}
	}
}

?>
