<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';

include_once 'core/UnixShellPeer.php';

/**
 * Base class that represents a row from the 'unix_shell' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to UnixShell class. 
 * 
 * @package core 
 */
abstract class BaseUnixShell extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var UnixShellPeer
	 */
	protected static $peer;

	/**
	 * The value for the unix_shell_id field.
	 * @var int	  
	 */
	protected $unix_shell_id;	

	/**
	 * The value for the shell_name field.
	 * @var string	  
	 */
	protected $shell_name;	

	/**
	 * The value for the path field.
	 * @var string	  
	 */
	protected $path;	
  
	/**
	 * Get the UnixShellId column value.
	 *  
	 * @return int	  
	 */
	public function getUnixShellId()
	{
		return $this->unix_shell_id;
	}


	/**
	 * Set the value of `unix_shell_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setUnixShellId($v)
	{
		if ($this->unix_shell_id !== $v) {
			$this->unix_shell_id = $v;
			$this->modifiedColumns[] = UnixShellPeer::UNIX_SHELL_ID;
		}
			
		  // update associated UserUnix		  
		  if ($this->collUserUnixs !== null) {
			  for ($i=0,$size=count($this->collUserUnixs); $i < $size; $i++) {
				  $this->collUserUnixs[$i]->setUnixShellId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the ShellName column value.
	 *  
	 * @return string	  
	 */
	public function getShellName()
	{
		return $this->shell_name;
	}


	/**
	 * Set the value of `shell_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setShellName($v)
	{
		if ($this->shell_name !== $v) {
			$this->shell_name = $v;
			$this->modifiedColumns[] = UnixShellPeer::SHELL_NAME;
		}
				
	}

  
	/**
	 * Get the Path column value.
	 *  
	 * @return string	  
	 */
	public function getPath()
	{
		return $this->path;
	}


	/**
	 * Set the value of `path` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setPath($v)
	{
		if ($this->path !== $v) {
			$this->path = $v;
			$this->modifiedColumns[] = UnixShellPeer::PATH;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->unix_shell_id = $rs->getInt($startcol + 0);					
			$this->shell_name = $rs->getString($startcol + 1);					
			$this->path = $rs->getString($startcol + 2);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating UnixShell object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(UnixShellPeer::DATABASE_NAME);
		$criteria->add(UnixShellPeer::UNIX_SHELL_ID, $this->unix_shell_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(UnixShellPeer::DATABASE_NAME);
		if ($this->isColumnModified(UnixShellPeer::UNIX_SHELL_ID)) $criteria->add(UnixShellPeer::UNIX_SHELL_ID, $this->unix_shell_id);
		if ($this->isColumnModified(UnixShellPeer::SHELL_NAME)) $criteria->add(UnixShellPeer::SHELL_NAME, $this->shell_name);
		if ($this->isColumnModified(UnixShellPeer::PATH)) $criteria->add(UnixShellPeer::PATH, $this->path);
		return $criteria;			
	}
	
	

	/**
	 * Collection to store aggregation of collUserUnixs	  
	 * @var array
	 */
	protected $collUserUnixs; 

	/**
	 * Temporary storage of collUserUnixs to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initUserUnixs()
	{
		if ($this->collUserUnixs === null) {
			$this->collUserUnixs = array();
		}
	}

	/**
	 * Method called to associate a UserUnix object to this object
	 * through the UserUnix foreign key attribute
	 *
	 * @param UserUnix $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addUserUnix(UserUnix $l)
	{
		$this->collUserUnixs[] = $l;
		$l->setUnixShell($this);
	}

	/**
	 * The criteria used to select the current contents of collUserUnixs.
	 * @var Criteria
	 */
	private $lastUserUnixsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this UnixShell has previously
	 * been saved, it will retrieve related UserUnixs from storage.
	 * If this UnixShell is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getUserUnixs($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserUnixPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collUserUnixs === null) {
			if ($this->isNew()) {
			   $this->collUserUnixs = array();
			} else {
	
				$criteria->add(UserUnixPeer::UNIX_SHELL_ID, $this->getUnixShellId() );

				$this->collUserUnixs = UserUnixPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(UserUnixPeer::UNIX_SHELL_ID, $this->getUnixShellId());

				if (!isset($this->lastUserUnixsCriteria) || !$this->lastUserUnixsCriteria->equals($criteria)) {
					$this->collUserUnixs = UserUnixPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUserUnixsCriteria = $criteria;

		return $this->collUserUnixs;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this UnixShell is new, it will return
	 * an empty collection; or if this UnixShell has previously
	 * been saved, it will retrieve related UserUnixs from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in UnixShell.
	 */
	public function getUserUnixsJoinUnixShell($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserUnixPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUserUnixs === null) {
			if ($this->isNew()) {
			   $this->collUserUnixs = array();
			} else {
	   
				$criteria->add(UserUnixPeer::UNIX_SHELL_ID, $this->getUnixShellId());
				$this->collUserUnixs = UserUnixPeer::doSelectJoinUnixShell($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserUnixPeer::UNIX_SHELL_ID, $this->getUnixShellId());
			if (!isset($this->lastUserUnixsCriteria) || !$this->lastUserUnixsCriteria->equals($criteria)) {
				$this->collUserUnixs = UserUnixPeer::doSelectJoinUnixShell($criteria, $con);
			}
		}
		$this->lastUserUnixsCriteria = $criteria;

		return $this->collUserUnixs;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this UnixShell is new, it will return
	 * an empty collection; or if this UnixShell has previously
	 * been saved, it will retrieve related UserUnixs from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in UnixShell.
	 */
	public function getUserUnixsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserUnixPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUserUnixs === null) {
			if ($this->isNew()) {
			   $this->collUserUnixs = array();
			} else {
	   
				$criteria->add(UserUnixPeer::UNIX_SHELL_ID, $this->getUnixShellId());
				$this->collUserUnixs = UserUnixPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserUnixPeer::UNIX_SHELL_ID, $this->getUnixShellId());
			if (!isset($this->lastUserUnixsCriteria) || !$this->lastUserUnixsCriteria->equals($criteria)) {
				$this->collUserUnixs = UserUnixPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastUserUnixsCriteria = $criteria;

		return $this->collUserUnixs;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("unix_shell_id", "shell_name", "path", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case UnixShellPeer::UNIX_SHELL_ID:
				return $this->getUnixShellId();
				break;
		  
			case UnixShellPeer::SHELL_NAME:
				return $this->getShellName();
				break;
		  
			case UnixShellPeer::PATH:
				return $this->getPath();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getUnixShellId();
				break;
  
			case 1:
				return $this->getShellName();
				break;
  
			case 2:
				return $this->getPath();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(UnixShellPeer::UNIX_SHELL_ID, $arr)) $this->setUnixShellId($arr[UnixShellPeer::UNIX_SHELL_ID]);
  
		if (array_key_exists(UnixShellPeer::SHELL_NAME, $arr)) $this->setShellName($arr[UnixShellPeer::SHELL_NAME]);
  
		if (array_key_exists(UnixShellPeer::PATH, $arr)) $this->setPath($arr[UnixShellPeer::PATH]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case UnixShellPeer::UNIX_SHELL_ID:
				$this->setUnixShellId($value);
				break;
	  
			case UnixShellPeer::SHELL_NAME:
				$this->setShellName($value);
				break;
	  
			case UnixShellPeer::PATH:
				$this->setPath($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setUnixShellId($value);
				break;
  
			case 1:
				$this->setShellName($value);
				break;
  
			case 2:
				$this->setPath($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(UnixShellPeer::DATABASE_NAME);

		try {
			$con->begin();
			UnixShellPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(UnixShellPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = UnixShellPeer::doInsert($this, $con);
					$this->setUnixShellId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					UnixShellPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collUserUnixs !== null) {
				for ($i=0,$size=count($this->collUserUnixs); $i < $size; $i++) {
					$this->collUserUnixs[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return UnixShellPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  

			if (($retval = UnixShellPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collUserUnixs !== null) {
				for ($i=0,$size=count($this->collUserUnixs); $i < $size; $i++) {
					if (($retval = $this->collUserUnixs[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed unix_shell_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setUnixShellId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getUnixShellId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return UnixShell Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new UnixShell();
		$copyObj->setShellName($this->shell_name);
		$copyObj->setPath($this->path);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getUserUnixs() as $relObj) {
				$copyObj->addUserUnix($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setUnixShellId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return UnixShellPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new UnixShellPeer();
		}
		return self::$peer;
	}

}
