<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/Project.php';
// (on-demand) include_once 'core/ProjectPeer.php';

include_once 'plugins/docman/lib/DocmanFolderPeer.php';

/**
 * Base class that represents a row from the 'docman_folder' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to DocmanFolder class. 
 * 
 * @package plugins.docman.lib 
 */
abstract class BaseDocmanFolder extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var DocmanFolderPeer
	 */
	protected static $peer;

	/**
	 * The value for the docman_folder_id field.
	 * @var int	  
	 */
	protected $docman_folder_id;	

	/**
	 * The value for the project_id field.
	 * @var int	  
	 */
	protected $project_id;	

	/**
	 * The value for the folder_name field.
	 * @var string	  
	 */
	protected $folder_name;	

	/**
	 * The value for the is_public field.
	 * @var boolean	  
	 */
	protected $is_public = true;	

	/**
	 * The value for the parent_folder_id field.
	 * @var int	  
	 */
	protected $parent_folder_id = 0;	

	/**
	 * The value for the doc_count field.
	 * @var int	  
	 */
	protected $doc_count = 0;	

	/**
	 * The value for the sort_order field.
	 * @var int	  
	 */
	protected $sort_order = 0;	
  
	/**
	 * Get the DocmanFolderId column value.
	 *  
	 * @return int	  
	 */
	public function getDocmanFolderId()
	{
		return $this->docman_folder_id;
	}


	/**
	 * Set the value of `docman_folder_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setDocmanFolderId($v)
	{
		if ($this->docman_folder_id !== $v) {
			$this->docman_folder_id = $v;
			$this->modifiedColumns[] = DocmanFolderPeer::DOCMAN_FOLDER_ID;
		}
			
		  // update associated DocmanFile		  
		  if ($this->collDocmanFiles !== null) {
			  for ($i=0,$size=count($this->collDocmanFiles); $i < $size; $i++) {
				  $this->collDocmanFiles[$i]->setDocmanFolderId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the ProjectId column value.
	 *  
	 * @return int	  
	 */
	public function getProjectId()
	{
		return $this->project_id;
	}


	/**
	 * Set the value of `project_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setProjectId($v)
	{
		if ($this->project_id !== $v) {
			$this->project_id = $v;
			$this->modifiedColumns[] = DocmanFolderPeer::PROJECT_ID;
		}
			
		if ($this->aProject !== null && $this->aProject->getProjectId() !== $v) {
			$this->aProject = null;
		}
			
	}

  
	/**
	 * Get the FolderName column value.
	 *  
	 * @return string	  
	 */
	public function getFolderName()
	{
		return $this->folder_name;
	}


	/**
	 * Set the value of `folder_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setFolderName($v)
	{
		if ($this->folder_name !== $v) {
			$this->folder_name = $v;
			$this->modifiedColumns[] = DocmanFolderPeer::FOLDER_NAME;
		}
				
	}

  
	/**
	 * Get the IsPublic column value.
	 *  
	 * @return boolean	  
	 */
	public function getIsPublic()
	{
		return $this->is_public;
	}


	/**
	 * Set the value of `is_public` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setIsPublic($v)
	{
		if ($this->is_public !== $v || $v === true) {
			$this->is_public = $v;
			$this->modifiedColumns[] = DocmanFolderPeer::IS_PUBLIC;
		}
				
	}

  
	/**
	 * Get the ParentFolderId column value.
	 *  
	 * @return int	  
	 */
	public function getParentFolderId()
	{
		return $this->parent_folder_id;
	}


	/**
	 * Set the value of `parent_folder_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setParentFolderId($v)
	{
		if ($this->parent_folder_id !== $v || $v === 0) {
			$this->parent_folder_id = $v;
			$this->modifiedColumns[] = DocmanFolderPeer::PARENT_FOLDER_ID;
		}
				
	}

  
	/**
	 * Get the DocCount column value.
	 *  
	 * @return int	  
	 */
	public function getDocCount()
	{
		return $this->doc_count;
	}


	/**
	 * Set the value of `doc_count` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setDocCount($v)
	{
		if ($this->doc_count !== $v || $v === 0) {
			$this->doc_count = $v;
			$this->modifiedColumns[] = DocmanFolderPeer::DOC_COUNT;
		}
				
	}

  
	/**
	 * Get the SortOrder column value.
	 *  
	 * @return int	  
	 */
	public function getSortOrder()
	{
		return $this->sort_order;
	}


	/**
	 * Set the value of `sort_order` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setSortOrder($v)
	{
		if ($this->sort_order !== $v || $v === 0) {
			$this->sort_order = $v;
			$this->modifiedColumns[] = DocmanFolderPeer::SORT_ORDER;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->docman_folder_id = $rs->getInt($startcol + 0);					
			$this->project_id = $rs->getInt($startcol + 1);					
			$this->folder_name = $rs->getString($startcol + 2);					
			$this->is_public = $rs->getBoolean($startcol + 3);					
			$this->parent_folder_id = $rs->getInt($startcol + 4);					
			$this->doc_count = $rs->getInt($startcol + 5);					
			$this->sort_order = $rs->getInt($startcol + 6);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating DocmanFolder object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(DocmanFolderPeer::DATABASE_NAME);
		$criteria->add(DocmanFolderPeer::DOCMAN_FOLDER_ID, $this->docman_folder_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(DocmanFolderPeer::DATABASE_NAME);
		if ($this->isColumnModified(DocmanFolderPeer::DOCMAN_FOLDER_ID)) $criteria->add(DocmanFolderPeer::DOCMAN_FOLDER_ID, $this->docman_folder_id);
		if ($this->isColumnModified(DocmanFolderPeer::PROJECT_ID)) $criteria->add(DocmanFolderPeer::PROJECT_ID, $this->project_id);
		if ($this->isColumnModified(DocmanFolderPeer::FOLDER_NAME)) $criteria->add(DocmanFolderPeer::FOLDER_NAME, $this->folder_name);
		if ($this->isColumnModified(DocmanFolderPeer::IS_PUBLIC)) $criteria->add(DocmanFolderPeer::IS_PUBLIC, $this->is_public);
		if ($this->isColumnModified(DocmanFolderPeer::PARENT_FOLDER_ID)) $criteria->add(DocmanFolderPeer::PARENT_FOLDER_ID, $this->parent_folder_id);
		if ($this->isColumnModified(DocmanFolderPeer::DOC_COUNT)) $criteria->add(DocmanFolderPeer::DOC_COUNT, $this->doc_count);
		if ($this->isColumnModified(DocmanFolderPeer::SORT_ORDER)) $criteria->add(DocmanFolderPeer::SORT_ORDER, $this->sort_order);
		return $criteria;			
	}
	
	

	/**
	 * @var Project	  
	 */
	protected $aProject;

	/**
	 * Declares an association between this object and a Project object
	 *
	 * @param Project $v
	 * @return void
	 * @throws PropelException
	 */
	public function setProject($v)
	{
			
		if ($v === null) {
			$this->setProjectId(NULL);
		} else {
			$this->setProjectId($v->getProjectId());
		}
   
		$this->aProject = $v;
	}


	/**
	 * Get the associated Project object
	 *
	 * @param Connection Optional Connection object.
	 * @return Project The associated Project object.
	 * @throws PropelException
	 */
	public function getProject($con = null)
	{
		// include the Peer class
		include_once 'core/ProjectPeer.php';

		if ($this->aProject === null && ($this->project_id !== null)) {
	
			$this->aProject = ProjectPeer::retrieveByPK($this->project_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ProjectPeer::retrieveByPK($this->project_id, $con);
			   $obj->addDocmanFolders($this);
			 */
		}
		return $this->aProject;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setProjectKey($key)
	{

		$this->setProjectId( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collDocmanFiles	  
	 * @var array
	 */
	protected $collDocmanFiles; 

	/**
	 * Temporary storage of collDocmanFiles to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initDocmanFiles()
	{
		if ($this->collDocmanFiles === null) {
			$this->collDocmanFiles = array();
		}
	}

	/**
	 * Method called to associate a DocmanFile object to this object
	 * through the DocmanFile foreign key attribute
	 *
	 * @param DocmanFile $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addDocmanFile(DocmanFile $l)
	{
		$this->collDocmanFiles[] = $l;
		$l->setDocmanFolder($this);
	}

	/**
	 * The criteria used to select the current contents of collDocmanFiles.
	 * @var Criteria
	 */
	private $lastDocmanFilesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this DocmanFolder has previously
	 * been saved, it will retrieve related DocmanFiles from storage.
	 * If this DocmanFolder is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getDocmanFiles($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/docman/lib/DocmanFilePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collDocmanFiles === null) {
			if ($this->isNew()) {
			   $this->collDocmanFiles = array();
			} else {
	
				$criteria->add(DocmanFilePeer::DOCMAN_FOLDER_ID, $this->getDocmanFolderId() );

				$this->collDocmanFiles = DocmanFilePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(DocmanFilePeer::DOCMAN_FOLDER_ID, $this->getDocmanFolderId());

				if (!isset($this->lastDocmanFilesCriteria) || !$this->lastDocmanFilesCriteria->equals($criteria)) {
					$this->collDocmanFiles = DocmanFilePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastDocmanFilesCriteria = $criteria;

		return $this->collDocmanFiles;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this DocmanFolder is new, it will return
	 * an empty collection; or if this DocmanFolder has previously
	 * been saved, it will retrieve related DocmanFiles from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in DocmanFolder.
	 */
	public function getDocmanFilesJoinDocmanFolder($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/docman/lib/DocmanFilePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collDocmanFiles === null) {
			if ($this->isNew()) {
			   $this->collDocmanFiles = array();
			} else {
	   
				$criteria->add(DocmanFilePeer::DOCMAN_FOLDER_ID, $this->getDocmanFolderId());
				$this->collDocmanFiles = DocmanFilePeer::doSelectJoinDocmanFolder($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(DocmanFilePeer::DOCMAN_FOLDER_ID, $this->getDocmanFolderId());
			if (!isset($this->lastDocmanFilesCriteria) || !$this->lastDocmanFilesCriteria->equals($criteria)) {
				$this->collDocmanFiles = DocmanFilePeer::doSelectJoinDocmanFolder($criteria, $con);
			}
		}
		$this->lastDocmanFilesCriteria = $criteria;

		return $this->collDocmanFiles;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("docman_folder_id", "project_id", "folder_name", "is_public", "parent_folder_id", "doc_count", "sort_order", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case DocmanFolderPeer::DOCMAN_FOLDER_ID:
				return $this->getDocmanFolderId();
				break;
		  
			case DocmanFolderPeer::PROJECT_ID:
				return $this->getProjectId();
				break;
		  
			case DocmanFolderPeer::FOLDER_NAME:
				return $this->getFolderName();
				break;
		  
			case DocmanFolderPeer::IS_PUBLIC:
				return $this->getIsPublic();
				break;
		  
			case DocmanFolderPeer::PARENT_FOLDER_ID:
				return $this->getParentFolderId();
				break;
		  
			case DocmanFolderPeer::DOC_COUNT:
				return $this->getDocCount();
				break;
		  
			case DocmanFolderPeer::SORT_ORDER:
				return $this->getSortOrder();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getDocmanFolderId();
				break;
  
			case 1:
				return $this->getProjectId();
				break;
  
			case 2:
				return $this->getFolderName();
				break;
  
			case 3:
				return $this->getIsPublic();
				break;
  
			case 4:
				return $this->getParentFolderId();
				break;
  
			case 5:
				return $this->getDocCount();
				break;
  
			case 6:
				return $this->getSortOrder();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(DocmanFolderPeer::DOCMAN_FOLDER_ID, $arr)) $this->setDocmanFolderId($arr[DocmanFolderPeer::DOCMAN_FOLDER_ID]);
  
		if (array_key_exists(DocmanFolderPeer::PROJECT_ID, $arr)) $this->setProjectId($arr[DocmanFolderPeer::PROJECT_ID]);
  
		if (array_key_exists(DocmanFolderPeer::FOLDER_NAME, $arr)) $this->setFolderName($arr[DocmanFolderPeer::FOLDER_NAME]);
  
		if (array_key_exists(DocmanFolderPeer::IS_PUBLIC, $arr)) $this->setIsPublic($arr[DocmanFolderPeer::IS_PUBLIC]);
  
		if (array_key_exists(DocmanFolderPeer::PARENT_FOLDER_ID, $arr)) $this->setParentFolderId($arr[DocmanFolderPeer::PARENT_FOLDER_ID]);
  
		if (array_key_exists(DocmanFolderPeer::DOC_COUNT, $arr)) $this->setDocCount($arr[DocmanFolderPeer::DOC_COUNT]);
  
		if (array_key_exists(DocmanFolderPeer::SORT_ORDER, $arr)) $this->setSortOrder($arr[DocmanFolderPeer::SORT_ORDER]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case DocmanFolderPeer::DOCMAN_FOLDER_ID:
				$this->setDocmanFolderId($value);
				break;
	  
			case DocmanFolderPeer::PROJECT_ID:
				$this->setProjectId($value);
				break;
	  
			case DocmanFolderPeer::FOLDER_NAME:
				$this->setFolderName($value);
				break;
	  
			case DocmanFolderPeer::IS_PUBLIC:
				$this->setIsPublic($value);
				break;
	  
			case DocmanFolderPeer::PARENT_FOLDER_ID:
				$this->setParentFolderId($value);
				break;
	  
			case DocmanFolderPeer::DOC_COUNT:
				$this->setDocCount($value);
				break;
	  
			case DocmanFolderPeer::SORT_ORDER:
				$this->setSortOrder($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setDocmanFolderId($value);
				break;
  
			case 1:
				$this->setProjectId($value);
				break;
  
			case 2:
				$this->setFolderName($value);
				break;
  
			case 3:
				$this->setIsPublic($value);
				break;
  
			case 4:
				$this->setParentFolderId($value);
				break;
  
			case 5:
				$this->setDocCount($value);
				break;
  
			case 6:
				$this->setSortOrder($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(DocmanFolderPeer::DATABASE_NAME);

		try {
			$con->begin();
			DocmanFolderPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(DocmanFolderPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aProject !== null) {
				if ($this->aProject->isModified()) $this->aProject->save($con);
				$this->setProject($this->aProject);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = DocmanFolderPeer::doInsert($this, $con);
					$this->setDocmanFolderId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					DocmanFolderPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collDocmanFiles !== null) {
				for ($i=0,$size=count($this->collDocmanFiles); $i < $size; $i++) {
					$this->collDocmanFiles[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return DocmanFolderPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aProject !== null) {
				if (($retval = $this->aProject->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = DocmanFolderPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collDocmanFiles !== null) {
				for ($i=0,$size=count($this->collDocmanFiles); $i < $size; $i++) {
					if (($retval = $this->collDocmanFiles[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed docman_folder_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setDocmanFolderId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getDocmanFolderId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return DocmanFolder Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new DocmanFolder();
		$copyObj->setProjectId($this->project_id);
		$copyObj->setFolderName($this->folder_name);
		$copyObj->setIsPublic($this->is_public);
		$copyObj->setParentFolderId($this->parent_folder_id);
		$copyObj->setDocCount($this->doc_count);
		$copyObj->setSortOrder($this->sort_order);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getDocmanFiles() as $relObj) {
				$copyObj->addDocmanFile($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setDocmanFolderId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return DocmanFolderPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new DocmanFolderPeer();
		}
		return self::$peer;
	}

}
