<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/forum/lib/html/ForumTemplate.php');
require_once('lib/plugin/PluginResult.php');

class ForumAdminTemplate extends ForumTemplate {

	/**
	 * Header - this subclasses header and just passes params and data that is specific
	 * to this template
	 * @param array array of parameters
	 */
	function header($params) {
		$Lang = Session::getSession()->getLanguage();

		if (!isset($params['project']) || !is_object($params['project'])) {
			throw new exception($Lang->getText('ForumTemplate.MissingProject'));
		}

		if( !($params['project']->getPermission()->check(ForumPlugin::SECTION,0,ForumPlugin::ADMIN) || $params['project']->getPermission()->check(ForumPlugin::SECTION,$params['forum_id'],ForumPlugin::ADMIN)) ) {
			Throw new PermissionDeniedException();
		}
		$this->addBreadCrumb('<a href="'.GFUrl::getUrl()->projectUrl($params['project'],'','forum/admin').'">'.$Lang->getText('Forum.AdminName').'</a>');
		
		return parent::header($params);
	}



	/**
	 * getTemplateNavElements - this function can be overridden
	 * by subclasses so you can add navigation entries
	 * @return array - complex array of data.
	 * /
	 
	function getTemplateNavElements($params) {
		$pine = $this->getPluginNavElements($params);
		foreach ($pine as $result) {
			$ret[]=$result->getResult();
		}
		if (!isset($params['project'])) {
			echo 'missing project param';
		}
		$ret[] = array(
			'title'=>'FRS',
			'elements'=> array(
			array('link'=> GFUrl::getUrl()->projectURL($params['project'], 'admin', 'forum'),
				'description'=>'Admin'),
			)
		);
		return $ret;
	}
	*/

}

?>
