<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'frs_release' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.frs.lib.map
 */
class FrsReleaseMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.frs.lib.map.FrsReleaseMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("frs_release");
		$tMap->setPhpName("FrsRelease");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("frs_release_frs_release_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("FRS_RELEASE_ID", "FrsReleaseId", "int", CreoleTypes::INTEGER, true);
		$tMap->addForeignKey("FRS_PACKAGE_ID", "FrsPackageId", "int", CreoleTypes::INTEGER, "frs_package" , "FRS_PACKAGE_ID", true);
		$tMap->addColumn("RELEASE_NAME", "ReleaseName", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("RELEASE_NOTES", "ReleaseNotes", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("CHANGES", "Changes", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("STATUS_ID", "StatusId", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("PREFORMATTED", "Preformatted", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("RELEASE_DATE", "ReleaseDate", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addForeignKey("RELEASED_BY", "ReleasedBy", "int", CreoleTypes::INTEGER, "user" , "USER_ID", true);
		$tMap->addColumn("IS_RELEASED", "IsReleased", "boolean", CreoleTypes::BOOLEAN, false, null);
				
    }
}
