<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Ruben Gutierrez	ruben@gforgegroup.com
 * @date 2006-03-13
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('lib/graphics/GraphicPie.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

$Project = GFUrl::getUrl()->getProject();
$project_id = $Project->getProjectId();


// Check if we want to filter by package
$package = (isset($_GET['frs_package_id']) ? Validator::sanitizeInt($_GET['frs_package_id']) : 0);
$begin = Validator::sanitizeDate($_GET['start_date']);
$end = Validator::sanitizeDate($_GET['end_date']);
$subprojects = ((isset($_REQUEST['subprojects'])) ? Validator::sanitizeInt($_REQUEST['subprojects']) : 0 );

$sqltime = "AND fsd.download_date BETWEEN '$begin 00:00:00' AND '$end 23:59:59.999'";

// If there's a valid project_id, we'll filter by project all the queries
$all_ids = $Project->getAllSubprojectIds();
$all_ids[] = $project_id;
if ($package > 0) {
	$sqlaux = "AND frsp.frs_package_id = '$package' AND frsp.project_id IN (".implode(',',$all_ids).") ";
} else {
	if ($subprojects == 1) {
		$sqlaux = "AND frsp.project_id IN (".implode(',',$all_ids).") ";
	} else {
		$sqlaux = "AND frsp.project_id = $project_id ";
	}
}

$sql = "SELECT COUNT(*) as downloads, frsr.release_name
FROM filesystem_download fsd, filesystem fs, frs_release frsr, frs_package frsp
WHERE fsd.filesystem_id = fs.filesystem_id
AND fs.section = 'frsrelease'
AND fs.ref_id = frsr.frs_release_id
AND frsr.frs_package_id = frsp.frs_package_id
$sqltime
$sqlaux
GROUP BY frsr.frs_release_id, frsr.release_name";

$gp = new GraphicPie($Lang->getText('FrsReporting.ByRelease'), 400, 250);
$gp->setSQL($sql);
$gp->setSQLFields('release_name', 'downloads');
$gp->showPie();
?>
