<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists News
//
require_once('plugins/news/lib/NewsPeer.php');
require_once('plugins/news/lib/News.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/news/lib/html/NewsAdminTemplate.php');
$theme = new NewsAdminTemplate();

$Project = GFUrl::getUrl()->getProject();

if(isset($_REQUEST['feedback'])) $feedback = $_REQUEST['feedback'];

$params = array(
		'project' => $Project,
	//	'News' => $News,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($feedback) ? $feedback : '',
		'title' => $Lang->getText('News.BrowsePageTitle')
		);
$theme->header($params);

$columns = array(
	NewsPeer::SUMMARY => $Lang->getText('News.SummaryName'),
	NewsPeer::DETAILS => $Lang->getText('News.DetailsName'),
	NewsPeer::POST_DATE => $Lang->getText('News.PostDateName'),
	$Lang->getText('News.Edit'),
	$Lang->getText('News.Delete')
	);
	
// Retrieve the objects array
$crit = new Criteria();
$crit->add(NewsPeer::PROJECT_ID, $Project->getProjectId());
$total = NewsPeer::doCount($crit);
$paginator = new Paginator('newsadm', -1, $total, NewsPeer::POST_DATE, $columns);
$paginator->addPageClauses($crit);
//$crit->addDescendingOrderByColumn(NewsPeer::POST_DATE);
$arr = NewsPeer::doSelect($crit);

/*$theader = array();
$theader[] = $Lang->getText('News.SummaryName');
$theader[] = $Lang->getText('News.DetailsName');
$theader[] = $Lang->getText('News.PostDateName');
$theader[] = $Lang->getText('News.Edit');
$theader[] = $Lang->getText('News.Delete');*/


$theader = $paginator->getSortableTableHeaders($theme);
//echo $paginator->showLimitOptions();

echo $theme->tableTop($theader);

if (count($arr) == 0) {
	echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('News.NoneFound').'</span>');
} else {
	foreach ($arr as $item) {
		$trow = array();
		$trow[]=$item->getSummary();
		$trow[]= StringUtils::addHtmlLinks(nl2br($item->getDetails()));
		$trow[]=$item->getPostDate();
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('NewsEdit',array('id'=>$item->getNewsID())).'">'. $Lang->getText('News.Edit').'</a>';
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('NewsDelete',array('id'=>$item->getNewsID())).'">'. $Lang->getText('News.Delete').'</a>';
		echo $theme->tableRow($trow);
	}
	//echo $theme->listPaginatorRow($paginator);
}
//echo $theme->tableBottom(array(GFUrl::getUrl()->currentBaseUrl('NewsAdd')=>$Lang->getText('News.AddNew')));
echo $theme->tableBottom(array(GFUrl::getURL()->projectUrl($Project,'NewsAdd','news','admin',array('return_to' => 'admin'))=>$Lang->getText('News.AddNew')),array(true));

if(isset($paginator) && is_object($paginator)) {
	echo '<div class="paginator">' . $paginator->getPaginator() . '</div><br />';
}

$theme->footer($params);
?>