<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/Project.php';
// (on-demand) include_once 'core/ProjectPeer.php';

include_once 'plugins/scm/lib/CodeSearchModulePeer.php';

/**
 * Base class that represents a row from the 'code_search_module' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to CodeSearchModule class. 
 * 
 * @package plugins.scm.lib 
 */
abstract class BaseCodeSearchModule extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var CodeSearchModulePeer
	 */
	protected static $peer;

	/**
	 * The value for the code_search_module_id field.
	 * @var int	  
	 */
	protected $code_search_module_id;	

	/**
	 * The value for the project_id field.
	 * @var int	  
	 */
	protected $project_id;	

	/**
	 * The value for the module field.
	 * @var string	  
	 */
	protected $module;	
  
	/**
	 * Get the CodeSearchModuleId column value.
	 *  
	 * @return int	  
	 */
	public function getCodeSearchModuleId()
	{
		return $this->code_search_module_id;
	}


	/**
	 * Set the value of `code_search_module_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setCodeSearchModuleId($v)
	{
		if ($this->code_search_module_id !== $v) {
			$this->code_search_module_id = $v;
			$this->modifiedColumns[] = CodeSearchModulePeer::CODE_SEARCH_MODULE_ID;
		}
			
		  // update associated CodeSearchIndex		  
		  if ($this->collCodeSearchIndexs !== null) {
			  for ($i=0,$size=count($this->collCodeSearchIndexs); $i < $size; $i++) {
				  $this->collCodeSearchIndexs[$i]->setCodeSearchModuleId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the ProjectId column value.
	 *  
	 * @return int	  
	 */
	public function getProjectId()
	{
		return $this->project_id;
	}


	/**
	 * Set the value of `project_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setProjectId($v)
	{
		if ($this->project_id !== $v) {
			$this->project_id = $v;
			$this->modifiedColumns[] = CodeSearchModulePeer::PROJECT_ID;
		}
			
		if ($this->aProject !== null && $this->aProject->getProjectId() !== $v) {
			$this->aProject = null;
		}
			
	}

  
	/**
	 * Get the Module column value.
	 *  
	 * @return string	  
	 */
	public function getModule()
	{
		return $this->module;
	}


	/**
	 * Set the value of `module` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setModule($v)
	{
		if ($this->module !== $v) {
			$this->module = $v;
			$this->modifiedColumns[] = CodeSearchModulePeer::MODULE;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->code_search_module_id = $rs->getInt($startcol + 0);					
			$this->project_id = $rs->getInt($startcol + 1);					
			$this->module = $rs->getString($startcol + 2);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating CodeSearchModule object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(CodeSearchModulePeer::DATABASE_NAME);
		$criteria->add(CodeSearchModulePeer::CODE_SEARCH_MODULE_ID, $this->code_search_module_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(CodeSearchModulePeer::DATABASE_NAME);
		if ($this->isColumnModified(CodeSearchModulePeer::CODE_SEARCH_MODULE_ID)) $criteria->add(CodeSearchModulePeer::CODE_SEARCH_MODULE_ID, $this->code_search_module_id);
		if ($this->isColumnModified(CodeSearchModulePeer::PROJECT_ID)) $criteria->add(CodeSearchModulePeer::PROJECT_ID, $this->project_id);
		if ($this->isColumnModified(CodeSearchModulePeer::MODULE)) $criteria->add(CodeSearchModulePeer::MODULE, $this->module);
		return $criteria;			
	}
	
	

	/**
	 * @var Project	  
	 */
	protected $aProject;

	/**
	 * Declares an association between this object and a Project object
	 *
	 * @param Project $v
	 * @return void
	 * @throws PropelException
	 */
	public function setProject($v)
	{
			
		if ($v === null) {
			$this->setProjectId(NULL);
		} else {
			$this->setProjectId($v->getProjectId());
		}
   
		$this->aProject = $v;
	}


	/**
	 * Get the associated Project object
	 *
	 * @param Connection Optional Connection object.
	 * @return Project The associated Project object.
	 * @throws PropelException
	 */
	public function getProject($con = null)
	{
		// include the Peer class
		include_once 'core/ProjectPeer.php';

		if ($this->aProject === null && ($this->project_id !== null)) {
	
			$this->aProject = ProjectPeer::retrieveByPK($this->project_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ProjectPeer::retrieveByPK($this->project_id, $con);
			   $obj->addCodeSearchModules($this);
			 */
		}
		return $this->aProject;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setProjectKey($key)
	{

		$this->setProjectId( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collCodeSearchIndexs	  
	 * @var array
	 */
	protected $collCodeSearchIndexs; 

	/**
	 * Temporary storage of collCodeSearchIndexs to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initCodeSearchIndexs()
	{
		if ($this->collCodeSearchIndexs === null) {
			$this->collCodeSearchIndexs = array();
		}
	}

	/**
	 * Method called to associate a CodeSearchIndex object to this object
	 * through the CodeSearchIndex foreign key attribute
	 *
	 * @param CodeSearchIndex $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addCodeSearchIndex(CodeSearchIndex $l)
	{
		$this->collCodeSearchIndexs[] = $l;
		$l->setCodeSearchModule($this);
	}

	/**
	 * The criteria used to select the current contents of collCodeSearchIndexs.
	 * @var Criteria
	 */
	private $lastCodeSearchIndexsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this CodeSearchModule has previously
	 * been saved, it will retrieve related CodeSearchIndexs from storage.
	 * If this CodeSearchModule is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getCodeSearchIndexs($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/CodeSearchIndexPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collCodeSearchIndexs === null) {
			if ($this->isNew()) {
			   $this->collCodeSearchIndexs = array();
			} else {
	
				$criteria->add(CodeSearchIndexPeer::CODE_SEARCH_MODULE_ID, $this->getCodeSearchModuleId() );

				$this->collCodeSearchIndexs = CodeSearchIndexPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(CodeSearchIndexPeer::CODE_SEARCH_MODULE_ID, $this->getCodeSearchModuleId());

				if (!isset($this->lastCodeSearchIndexsCriteria) || !$this->lastCodeSearchIndexsCriteria->equals($criteria)) {
					$this->collCodeSearchIndexs = CodeSearchIndexPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCodeSearchIndexsCriteria = $criteria;

		return $this->collCodeSearchIndexs;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this CodeSearchModule is new, it will return
	 * an empty collection; or if this CodeSearchModule has previously
	 * been saved, it will retrieve related CodeSearchIndexs from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in CodeSearchModule.
	 */
	public function getCodeSearchIndexsJoinCodeSearchModule($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/CodeSearchIndexPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCodeSearchIndexs === null) {
			if ($this->isNew()) {
			   $this->collCodeSearchIndexs = array();
			} else {
	   
				$criteria->add(CodeSearchIndexPeer::CODE_SEARCH_MODULE_ID, $this->getCodeSearchModuleId());
				$this->collCodeSearchIndexs = CodeSearchIndexPeer::doSelectJoinCodeSearchModule($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CodeSearchIndexPeer::CODE_SEARCH_MODULE_ID, $this->getCodeSearchModuleId());
			if (!isset($this->lastCodeSearchIndexsCriteria) || !$this->lastCodeSearchIndexsCriteria->equals($criteria)) {
				$this->collCodeSearchIndexs = CodeSearchIndexPeer::doSelectJoinCodeSearchModule($criteria, $con);
			}
		}
		$this->lastCodeSearchIndexsCriteria = $criteria;

		return $this->collCodeSearchIndexs;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("code_search_module_id", "project_id", "module", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case CodeSearchModulePeer::CODE_SEARCH_MODULE_ID:
				return $this->getCodeSearchModuleId();
				break;
		  
			case CodeSearchModulePeer::PROJECT_ID:
				return $this->getProjectId();
				break;
		  
			case CodeSearchModulePeer::MODULE:
				return $this->getModule();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getCodeSearchModuleId();
				break;
  
			case 1:
				return $this->getProjectId();
				break;
  
			case 2:
				return $this->getModule();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(CodeSearchModulePeer::CODE_SEARCH_MODULE_ID, $arr)) $this->setCodeSearchModuleId($arr[CodeSearchModulePeer::CODE_SEARCH_MODULE_ID]);
  
		if (array_key_exists(CodeSearchModulePeer::PROJECT_ID, $arr)) $this->setProjectId($arr[CodeSearchModulePeer::PROJECT_ID]);
  
		if (array_key_exists(CodeSearchModulePeer::MODULE, $arr)) $this->setModule($arr[CodeSearchModulePeer::MODULE]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case CodeSearchModulePeer::CODE_SEARCH_MODULE_ID:
				$this->setCodeSearchModuleId($value);
				break;
	  
			case CodeSearchModulePeer::PROJECT_ID:
				$this->setProjectId($value);
				break;
	  
			case CodeSearchModulePeer::MODULE:
				$this->setModule($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setCodeSearchModuleId($value);
				break;
  
			case 1:
				$this->setProjectId($value);
				break;
  
			case 2:
				$this->setModule($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(CodeSearchModulePeer::DATABASE_NAME);

		try {
			$con->begin();
			CodeSearchModulePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(CodeSearchModulePeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aProject !== null) {
				if ($this->aProject->isModified()) $this->aProject->save($con);
				$this->setProject($this->aProject);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = CodeSearchModulePeer::doInsert($this, $con);
					$this->setCodeSearchModuleId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					CodeSearchModulePeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collCodeSearchIndexs !== null) {
				for ($i=0,$size=count($this->collCodeSearchIndexs); $i < $size; $i++) {
					$this->collCodeSearchIndexs[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return CodeSearchModulePeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aProject !== null) {
				if (($retval = $this->aProject->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = CodeSearchModulePeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collCodeSearchIndexs !== null) {
				for ($i=0,$size=count($this->collCodeSearchIndexs); $i < $size; $i++) {
					if (($retval = $this->collCodeSearchIndexs[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed code_search_module_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setCodeSearchModuleId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getCodeSearchModuleId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return CodeSearchModule Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new CodeSearchModule();
		$copyObj->setProjectId($this->project_id);
		$copyObj->setModule($this->module);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getCodeSearchIndexs() as $relObj) {
				$copyObj->addCodeSearchIndex($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setCodeSearchModuleId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return CodeSearchModulePeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new CodeSearchModulePeer();
		}
		return self::$peer;
	}

}
