<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'plugins/scm/lib/ScmCommit.php';
// (on-demand) include_once 'plugins/scm/lib/ScmCommitPeer.php';

include_once 'plugins/scm/lib/ScmCommitFilePeer.php';

/**
 * Base class that represents a row from the 'scm_commit_file' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to ScmCommitFile class. 
 * 
 * @package plugins.scm.lib 
 */
abstract class BaseScmCommitFile extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var ScmCommitFilePeer
	 */
	protected static $peer;

	/**
	 * The value for the scm_commit_id field.
	 * @var int	  
	 */
	protected $scm_commit_id;	

	/**
	 * The value for the modified_file field.
	 * @var string	  
	 */
	protected $modified_file = '';	

	/**
	 * The value for the prev_version field.
	 * @var string	  
	 */
	protected $prev_version = '';	

	/**
	 * The value for the new_version field.
	 * @var string	  
	 */
	protected $new_version = '';	

	/**
	 * The value for the changed_lines field.
	 * @var int	  
	 */
	protected $changed_lines = 0;	
  
	/**
	 * Get the ScmCommitId column value.
	 *  
	 * @return int	  
	 */
	public function getScmCommitId()
	{
		return $this->scm_commit_id;
	}


	/**
	 * Set the value of `scm_commit_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setScmCommitId($v)
	{
		if ($this->scm_commit_id !== $v) {
			$this->scm_commit_id = $v;
			$this->modifiedColumns[] = ScmCommitFilePeer::SCM_COMMIT_ID;
		}
			
		if ($this->aScmCommit !== null && $this->aScmCommit->getScmCommitId() !== $v) {
			$this->aScmCommit = null;
		}
			
	}

  
	/**
	 * Get the ModifiedFile column value.
	 *  
	 * @return string	  
	 */
	public function getModifiedFile()
	{
		return $this->modified_file;
	}


	/**
	 * Set the value of `modified_file` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setModifiedFile($v)
	{
		if ($this->modified_file !== $v || $v === '') {
			$this->modified_file = $v;
			$this->modifiedColumns[] = ScmCommitFilePeer::MODIFIED_FILE;
		}
				
	}

  
	/**
	 * Get the PrevVersion column value.
	 *  
	 * @return string	  
	 */
	public function getPrevVersion()
	{
		return $this->prev_version;
	}


	/**
	 * Set the value of `prev_version` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setPrevVersion($v)
	{
		if ($this->prev_version !== $v || $v === '') {
			$this->prev_version = $v;
			$this->modifiedColumns[] = ScmCommitFilePeer::PREV_VERSION;
		}
				
	}

  
	/**
	 * Get the NewVersion column value.
	 *  
	 * @return string	  
	 */
	public function getNewVersion()
	{
		return $this->new_version;
	}


	/**
	 * Set the value of `new_version` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setNewVersion($v)
	{
		if ($this->new_version !== $v || $v === '') {
			$this->new_version = $v;
			$this->modifiedColumns[] = ScmCommitFilePeer::NEW_VERSION;
		}
				
	}

  
	/**
	 * Get the ChangedLines column value.
	 *  
	 * @return int	  
	 */
	public function getChangedLines()
	{
		return $this->changed_lines;
	}


	/**
	 * Set the value of `changed_lines` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setChangedLines($v)
	{
		if ($this->changed_lines !== $v || $v === 0) {
			$this->changed_lines = $v;
			$this->modifiedColumns[] = ScmCommitFilePeer::CHANGED_LINES;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->scm_commit_id = $rs->getInt($startcol + 0);					
			$this->modified_file = $rs->getString($startcol + 1);					
			$this->prev_version = $rs->getString($startcol + 2);					
			$this->new_version = $rs->getString($startcol + 3);					
			$this->changed_lines = $rs->getInt($startcol + 4);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating ScmCommitFile object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(ScmCommitFilePeer::DATABASE_NAME);
		$criteria->add(ScmCommitFilePeer::SCM_COMMIT_ID, $this->scm_commit_id);
		$criteria->add(ScmCommitFilePeer::MODIFIED_FILE, $this->modified_file);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(ScmCommitFilePeer::DATABASE_NAME);
		if ($this->isColumnModified(ScmCommitFilePeer::SCM_COMMIT_ID)) $criteria->add(ScmCommitFilePeer::SCM_COMMIT_ID, $this->scm_commit_id);
		if ($this->isColumnModified(ScmCommitFilePeer::MODIFIED_FILE)) $criteria->add(ScmCommitFilePeer::MODIFIED_FILE, $this->modified_file);
		if ($this->isColumnModified(ScmCommitFilePeer::PREV_VERSION)) $criteria->add(ScmCommitFilePeer::PREV_VERSION, $this->prev_version);
		if ($this->isColumnModified(ScmCommitFilePeer::NEW_VERSION)) $criteria->add(ScmCommitFilePeer::NEW_VERSION, $this->new_version);
		if ($this->isColumnModified(ScmCommitFilePeer::CHANGED_LINES)) $criteria->add(ScmCommitFilePeer::CHANGED_LINES, $this->changed_lines);
		return $criteria;			
	}
	
	

	/**
	 * @var ScmCommit	  
	 */
	protected $aScmCommit;

	/**
	 * Declares an association between this object and a ScmCommit object
	 *
	 * @param ScmCommit $v
	 * @return void
	 * @throws PropelException
	 */
	public function setScmCommit($v)
	{
			
		if ($v === null) {
			$this->setScmCommitId(NULL);
		} else {
			$this->setScmCommitId($v->getScmCommitId());
		}
   
		$this->aScmCommit = $v;
	}


	/**
	 * Get the associated ScmCommit object
	 *
	 * @param Connection Optional Connection object.
	 * @return ScmCommit The associated ScmCommit object.
	 * @throws PropelException
	 */
	public function getScmCommit($con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmCommitPeer.php';

		if ($this->aScmCommit === null && ($this->scm_commit_id !== null)) {
	
			$this->aScmCommit = ScmCommitPeer::retrieveByPK($this->scm_commit_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ScmCommitPeer::retrieveByPK($this->scm_commit_id, $con);
			   $obj->addScmCommitFiles($this);
			 */
		}
		return $this->aScmCommit;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setScmCommitKey($key)
	{

		$this->setScmCommitId( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("scm_commit_id", "modified_file", "prev_version", "new_version", "changed_lines", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case ScmCommitFilePeer::SCM_COMMIT_ID:
				return $this->getScmCommitId();
				break;
		  
			case ScmCommitFilePeer::MODIFIED_FILE:
				return $this->getModifiedFile();
				break;
		  
			case ScmCommitFilePeer::PREV_VERSION:
				return $this->getPrevVersion();
				break;
		  
			case ScmCommitFilePeer::NEW_VERSION:
				return $this->getNewVersion();
				break;
		  
			case ScmCommitFilePeer::CHANGED_LINES:
				return $this->getChangedLines();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getScmCommitId();
				break;
  
			case 1:
				return $this->getModifiedFile();
				break;
  
			case 2:
				return $this->getPrevVersion();
				break;
  
			case 3:
				return $this->getNewVersion();
				break;
  
			case 4:
				return $this->getChangedLines();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(ScmCommitFilePeer::SCM_COMMIT_ID, $arr)) $this->setScmCommitId($arr[ScmCommitFilePeer::SCM_COMMIT_ID]);
  
		if (array_key_exists(ScmCommitFilePeer::MODIFIED_FILE, $arr)) $this->setModifiedFile($arr[ScmCommitFilePeer::MODIFIED_FILE]);
  
		if (array_key_exists(ScmCommitFilePeer::PREV_VERSION, $arr)) $this->setPrevVersion($arr[ScmCommitFilePeer::PREV_VERSION]);
  
		if (array_key_exists(ScmCommitFilePeer::NEW_VERSION, $arr)) $this->setNewVersion($arr[ScmCommitFilePeer::NEW_VERSION]);
  
		if (array_key_exists(ScmCommitFilePeer::CHANGED_LINES, $arr)) $this->setChangedLines($arr[ScmCommitFilePeer::CHANGED_LINES]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case ScmCommitFilePeer::SCM_COMMIT_ID:
				$this->setScmCommitId($value);
				break;
	  
			case ScmCommitFilePeer::MODIFIED_FILE:
				$this->setModifiedFile($value);
				break;
	  
			case ScmCommitFilePeer::PREV_VERSION:
				$this->setPrevVersion($value);
				break;
	  
			case ScmCommitFilePeer::NEW_VERSION:
				$this->setNewVersion($value);
				break;
	  
			case ScmCommitFilePeer::CHANGED_LINES:
				$this->setChangedLines($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setScmCommitId($value);
				break;
  
			case 1:
				$this->setModifiedFile($value);
				break;
  
			case 2:
				$this->setPrevVersion($value);
				break;
  
			case 3:
				$this->setNewVersion($value);
				break;
  
			case 4:
				$this->setChangedLines($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(ScmCommitFilePeer::DATABASE_NAME);

		try {
			$con->begin();
			ScmCommitFilePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(ScmCommitFilePeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aScmCommit !== null) {
				if ($this->aScmCommit->isModified()) $this->aScmCommit->save($con);
				$this->setScmCommit($this->aScmCommit);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ScmCommitFilePeer::doInsert($this, $con);
					$this->setNew(false);
				} else {
					ScmCommitFilePeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return ScmCommitFilePeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aScmCommit !== null) {
				if (($retval = $this->aScmCommit->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = ScmCommitFilePeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  


	private $pks = array();
	
	/**
	 * Set the PrimaryKey.
	 *
	 * @param array $keys The elements of the composite key (order must match the order in XML file).
	 * @return void
	 * @throws PropelException
	 */
	public function setPrimaryKey($keys)
	{						

		$this->setScmCommitId($keys[0]);

		$this->setModifiedFile($keys[1]);

	}


	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return array 
	 */
	public function getPrimaryKey()
	{
		$this->pks[0] = $this->getScmCommitId();
		$this->pks[1] = $this->getModifiedFile();
		return $this->pks;

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return ScmCommitFile Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new ScmCommitFile();
		$copyObj->setPrevVersion($this->prev_version);
		$copyObj->setNewVersion($this->new_version);
		$copyObj->setChangedLines($this->changed_lines);
		
		$copyObj->setNew(true);
		
		$copyObj->setScmCommitId(NULL); // this is a pkey column, so set to default value
		$copyObj->setModifiedFile(''); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return ScmCommitFilePeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ScmCommitFilePeer();
		}
		return self::$peer;
	}

}
