<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a ScmModule and saves it to the 
// database
//
require_once('plugins/scm/lib/ScmCommitFilterProject.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

//As the code below is deleting all objects in one sweep, we need to check permissions before doing so.

if(!$project->userIsAdmin()) {
	throw new PermissionDeniedException();
}

$c = new Criteria();
$c->add(ScmCommitFilterProjectPeer::PROJECT_ID, $project->getProjectId());
ScmCommitFilterProjectPeer::doDelete($c);
if (isset($_POST['scm_commit_filters']) && is_array($_POST['scm_commit_filters'])) {
	foreach ($_POST['scm_commit_filters'] as $scm_commit_filter_id) {
		$scm_commit_filter_id = Validator::sanitizeInt($scm_commit_filter_id);
		$filter_project = new ScmCommitFilterProject();
		$filter_project->setScmCommitFilterId($scm_commit_filter_id);
		$filter_project->setProjectId($project->getProjectId());
		$filter_project->save();
	}
}

GFUrl::redirect(GFUrl::getUrl()->currentBaseUrl('ScmCommitFilterProjectBrowse', array('feedback' => $Lang->getText('ScmCommitFilter.EditFeedback'))));
?>