<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new ScmModule and saves it to the 
// database
//
require_once('plugins/scm/lib/ScmModule.php');
require_once('Validator.php');
require_once('exceptions/InvalidDataException.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

$project = GFUrl::getUrl()->getProject();

$SelectedScmModuleId = isset($_POST['publish_to_www']) ? Validator::sanitizeInt($_POST['publish_to_www']) : 0;

// Retrieve the objects array
$crit = new Criteria();
$crit->add(ScmModulePeer::PROJECT_ID, $project->getProjectId());
$ScmModules = ScmModulePeer::doSelect($crit);

$Lang = Language::getSessLang();

try {
	foreach ($ScmModules as $ScmModule) {
		if ($ScmModule->getScmModuleId() == $SelectedScmModuleId) {
			$ScmModule->setPublishToWww(true);
			$ScmModule->save();
		} else {
			$ScmModule->setPublishToWww(false);
			$ScmModule->save();
		}
	}
	GFUrl::redirect(GFUrl::getUrl()->currentBaseURL('ScmModuleBrowse'), array('feedback' => $Lang->getText('ScmModule.ModulesUpdated')));
} catch (Exception $ex) {
	$errors = $ex->getErrors();		// attach object errors to validation errors
	$feedback = '* '.implode('<br />* ', $errors);
	GFUrl::redirect(GFUrl::getUrl()->currentBaseURL('ScmModuleBrowse'), array('feedback' => $feedback));
}
?>