<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: index.php 1322 2006-07-31 18:00:42Z federicot $
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('GFUrl.php');
require_once('plugins/scm/lib/RepositoryBrowser.php');
require_once('plugins/scmperforce/lib/html/PerforceTemplate.php');
require_once('plugins/scmperforce/lib/PerforceBrowser.php');
require_once('plugins/scmperforce/lib/PerforceRepository.php');

$lang = $session->getLanguage();
$template = new PerforceTemplate();
$project = GFUrl::getUrl()->getProject();

$params = array(
	'selectedbottomtab'	=> 'scmperforce',
	'project' => $project,
	'action' => isset($action) ? $action : '',
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	'title' => $lang->getText('Scmperforce.Browse')
	);

$perforceplugin = $project->getPluginByName('scmperforce');
if (is_null($perforceplugin)) {
	throw new InvalidPluginException('scmperforce');
}

$repos = new PerforceRepository($project);

$session = Session::getSession();

if ($repos->getScmConfiguration()->getControlled()) {
	// Repository is controlled by GForge
	$browser = new PerforceBrowser($repos);
	$browser->parseQuery($_SERVER['QUERY_STRING']);
} else {
	// Repository is externally controlled
	$template->header($params);
	echo '<h1>'.$lang->getText('Scmcvs.BrowseTitle').'</h1>';
	$browse_text = $repos->getScmConfiguration()->getBrowseText();
	if (!empty($browse_text)){
		echo $browse_text.'<br /><br />';
	}
	
	$external_url = $repos->getScmConfiguration()->getExternalBrowseUrl();
	if (!empty($external_url)) {
		echo $lang->getText('Scm.RemoteBrowseUrl', array($external_url));
	}
}

$template->footer($params);

?>
