<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2005-11-11
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once 'plugins/tracker/lib/om/BaseTrackerExtraFieldElement.php';
require_once("plugin/ActionManager.php");

/** 
 * The skeleton for this class was autogenerated by Propel  on:
 *
 * [Wed Nov 16 20:42:33 2005]
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package plugins.tracker.lib 
 */
class TrackerExtraFieldElement extends BaseTrackerExtraFieldElement {
	/**
	 * Removes this object from datastore and sets delete attribute. Informs the plugin manager.
	 * This method was added by propel_customizer.php.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see TrackerExtraFieldElement::setDeleted()
	 * @see TrackerExtraFieldElement::isDeleted()
	 */
	 
	const ELEMENT_NONE = 100;
	
	const ACTION_CREATE = 1;
	const ACTION_UPDATE = 2;
	const ACTION_DELETE = 3;
	
	protected $is_template_element = null;
	protected $old_element_name = null;

	function delete($con = null) {
			
		if (!$this->getTrackerExtraField()->getTracker()->userIsAdmin()) {
			throw new PermissionDeniedException();
		}
		
		$con = Propel::getConnection(TrackerExtraFieldDataPeer::DATABASE_NAME);
		$stmt = $con->createStatement();
		$sql = 'UPDATE tracker_extra_field_data SET field_data = 100 WHERE tracker_extra_field_id ='.$this->getTrackerExtraFieldId().' AND field_data = '.$this->getElementId();
		$rs = $stmt->executeQuery($sql);
		
		$this->updateTemplate(TrackerExtraFieldElement::ACTION_DELETE);

		ActionManager::notify("TRACKER_EXTRA_FIELD_ELEMENT_DELETE", $this);
		parent::delete($con);		
	}
	
	function setElementName($string) {
		if (is_null($this->old_element_name)) {
			// Must store this for being able to replicate changes to
			// other elements
			$this->old_element_name = $this->getElementName();
		}
		parent::setElementName($string);
	}

	/**
	 * Stores the object in the database using the Propel methods. Informs the plugin manager.
	 * This method was added by propel_customizer.php.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	function save($con = null) {
		if (!$this->getTrackerExtraField()->getTracker()->userIsAdmin()) {
			throw new PermissionDeniedException();
		}
		$errors=array();
		if (strlen($this->element_name) < 1) {
			$errors['element_name'] = Language::getSessText('TrackerExtraFieldElement.EmptyName');
		}
		if (count($errors) > 0) {
			throw new InvalidDataException($errors);
		}
		
		$isnew=$this->isNew();
		parent::save($con);
		ActionManager::notify("TRACKER_EXTRA_FIELD_ELEMENT_SAVE", $this);
		
		if ($isnew) {
			$this->updateTemplate(TrackerExtraFieldElement::ACTION_CREATE);
		} else {
			$this->updateTemplate(TrackerExtraFieldElement::ACTION_UPDATE);
		}
		
	}

	function getId() {
		return $this->getElementId();
	}
	function getName() {
		return $this->getElementName();
	}
	
	public function isTemplateElement() {
		if (is_null($this->is_template_element)) {
			$this->is_template_element = $this->getTrackerExtraField()->getTracker()->getProject()->getIsTemplate();
		}		
		return $this->is_template_element;
	}
	
	/**
	 * This function replicates the changes across the projects that have this project
	 * as template
	 */	
	private function updateTemplate($action) {
		// Replicate the data only if it's an element on a template project and it's a
		// site admin
		if (!$this->isTemplateElement() || !Session::getSession()->isSiteAdmin()) {
			return;
		}

		$ef = $this->getTrackerExtraField();
		
		switch ($action) {
		case TrackerExtraFieldElement::ACTION_CREATE:
			// Get a list of all the fields that have to be updated
			$c = new Criteria();
			$c->add(TrackerExtraFieldPeer::FIELD_NAME, $ef->getFieldName());
			$c->addJoin(TrackerExtraFieldPeer::TRACKER_ID, TrackerPeer::TRACKER_ID);
			$c->add(TrackerPeer::TRACKER_NAME, $ef->getTracker()->getTrackerName());
			$c->addJoin(TrackerPeer::PROJECT_ID, ProjectPeer::PROJECT_ID);
			$c->add(ProjectPeer::TEMPLATE_PROJECT_ID, $ef->getTracker()->getProjectId());
			$extra_fields = TrackerExtraFieldPeer::doSelect($c);
			foreach ($extra_fields as $extra_field) {
				if ($extra_field->getTrackerExtraFieldId() == $this->getTrackerExtraFieldId()) {
					// Shouldn't happen, means that the project.template_project_id=project.project_id
					// but we avoid infinite loop anyways
					continue;
				}
				$new_element = $this->copy();
				$new_element->setTrackerExtraField($extra_field);
				// For now, ignore workflow data
				$new_element->setAutoAssignTo(null);
				$new_element->save();
			}
			break;
		case TrackerExtraFieldElement::ACTION_UPDATE:
			// Get the list of elements that must be updated
			if (!is_null($this->old_element_name)) {
				$old_element_name = $this->old_element_name;
			} else {
				// This means the field name wasn't changed
				$old_element_name = $this->getElementName();
			}
			
			$c = new Criteria();
			$c->add(TrackerExtraFieldElementPeer::ELEMENT_NAME, $old_element_name);
			$c->addJoin(TrackerExtraFieldElementPeer::TRACKER_EXTRA_FIELD_ID, TrackerExtraFieldPeer::TRACKER_EXTRA_FIELD_ID);
			$c->add(TrackerExtraFieldPeer::FIELD_NAME, $ef->getFieldName());
			$c->addJoin(TrackerExtraFieldPeer::TRACKER_ID, TrackerPeer::TRACKER_ID);
			$c->add(TrackerPeer::TRACKER_NAME, $ef->getTracker()->getTrackerName());
			$c->addJoin(TrackerPeer::PROJECT_ID, ProjectPeer::PROJECT_ID);
			$c->add(ProjectPeer::TEMPLATE_PROJECT_ID, $ef->getTracker()->getProjectId());
			$elements = TrackerExtraFieldElementPeer::doSelect($c);
			foreach ($elements as $element) {
				if ($element->getElementId() == $this->getElementId()) {
					continue;
				}
				$element->setElementName($this->getElementName());
				$element->setStatusId($this->getStatusId());
				$element->setDefaultSelected($this->getDefaultSelected());
				$element->setSortOrder($this->getSortOrder());
				$element->setCanCommit($this->getCanCommit());
				$element->save();
			}
			break;		
		case TrackerExtraFieldElement::ACTION_DELETE:
			// Get the list of elements that must be deleted
			$c = new Criteria();
			$c->add(TrackerExtraFieldElementPeer::ELEMENT_NAME, $this->getElementName());
			$c->addJoin(TrackerExtraFieldElementPeer::TRACKER_EXTRA_FIELD_ID, TrackerExtraFieldPeer::TRACKER_EXTRA_FIELD_ID);
			$c->add(TrackerExtraFieldPeer::FIELD_NAME, $ef->getFieldName());
			$c->addJoin(TrackerExtraFieldPeer::TRACKER_ID, TrackerPeer::TRACKER_ID);
			$c->add(TrackerPeer::TRACKER_NAME, $ef->getTracker()->getTrackerName());
			$c->addJoin(TrackerPeer::PROJECT_ID, ProjectPeer::PROJECT_ID);
			$c->add(ProjectPeer::TEMPLATE_PROJECT_ID, $ef->getTracker()->getProjectId());
			$elements = TrackerExtraFieldElementPeer::doSelect($c);
			foreach ($elements as $element) {
				if ($element->getElementId() == $this->getElementId()) {
					continue;
				}
				
				$element->delete();
			}
			break;
		}
	}

}
?>
