<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version	  $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This	file is	part of	GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This	code shows a form for TrackerExtraFieldElementTransition
//
require_once('GFUrl.php');
require_once('lib/html/HTMLWidget.php');
require_once('plugins/tracker/lib/TrackerCommitReassignTrigger.php');
require_once('plugins/tracker/lib/TrackerCommitTrigger.php');

$session = Session::getSession();
$Lang =	$session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerAdminTemplate.php');
$theme = new TrackerAdminTemplate();

$project = GFUrl::getUrl()->getProject();
$tracker = TrackerPeer::retrieveByPk($_REQUEST['tracker_id']);
if (!is_object($tracker) || !$tracker->userIsAdmin() || $tracker->getProject()->getProjectId() != $project->getProjectId()) {
	throw new PermissionDeniedException();
}

$params = array(
		'project' => $project,
		'tracker' => $tracker,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('Tracker.TrackerCommitEditTitle')
		);
	

$c = new Criteria();
$c->add(TrackerCommitReassignTriggerPeer::TRACKER_ID, $tracker->getTrackerId());
$assign_to_roles = TrackerCommitReassignTriggerPeer::doSelect($c);
$assign_to=array();
foreach	($assign_to_roles as $assign_to_role) {
	$assign_to[] = $assign_to_role->getAssignToRoleId();
}

// Extra fields	to update
$available_extra_fields_to	= array();
$available_elements = array();
$c = new Criteria();
$c->add(TrackerExtraFieldPeer::TRACKER_ID, $tracker->getTrackerId());
$extra_fields =	TrackerExtraFieldPeer::doSelect($c);
foreach	($extra_fields as $extra_field)	{
	switch ($extra_field->getFieldType()) {
	case TrackerExtraField::TYPE_SELECT:
	case TrackerExtraField::TYPE_RADIO:
	case TrackerExtraField::TYPE_STATUS:
		$available_extra_fields_to[] = $extra_field;
		// Get the values
		$available_elements[$extra_field->getTrackerExtraFieldId()] = $extra_field->getTrackerExtraFieldElements();
		break;
	default:
		break;
	}
}

// Get the default value to switch to
// NOTE: currently only one field is allowed to change
$c = new Criteria();
$c->add(TrackerCommitTriggerPeer::TRACKER_ID, $tracker->getTrackerId());
$trigger = TrackerCommitTriggerPeer::doSelectOne($c);
if (is_object($trigger)) {
	$default_change_extra_field_id = $trigger->getChangeTrackerExtraFieldId();
	$default_to_element_id = $trigger->getToElementId();
} else {
	$default_change_extra_field_id = 0;
	$default_to_element_id = 0;
}

include('forms/TrackerCommitEdit-tpl.php');

?>
