<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a TrackerTimeCode and saves it to the 
// database
//
require_once('plugins/tracker/lib/TrackerTimeCode.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}
if (!Session::getSession()->isSiteAdmin()) {
	throw new PermissionDeniedException();
}

$TrackerTimeCode = TrackerTimeCodePeer::retrieveByPk($_POST['tracker_time_code_id']);
if (!is_object($TrackerTimeCode)) {
	throw new PermissionDeniedException();
}

$errors = array();
$language = Language::getSessLang();

$TrackerTimeCode->setTimeName( Validator::sanitizeString($_POST['time_name']) );

try {
	$TrackerTimeCode->save();
} catch (InvalidDataException $ex) {
	$errors = array_merge($errors, $ex->getErrors());               // attach object errors to validation errors
}

if (count($errors) > 0) {
	$feedback = '* '.implode('<br />* ', $errors);
	GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL('TrackerTimeCodeEdit'), array('feedback' => $feedback, 'tracker_time_code_id' => $_POST['tracker_time_code_id']));
} else {
	GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL('TrackerTimeCodeBrowse'), array('feedback' => $language->getText('TrackerTimeCode.EditFeedback')));
}
?>
