<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a Snippet and saves it to the 
// database
//

require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

$c = new Criteria();
$c->add(FilesystemPeer::FILESYSTEM_ID,$_REQUEST['file_id']);
$fs = FilesystemPeer::doSelectOne($c);
if (!is_object($fs)) {
	throw new PermissionDeniedException();
}

$errors = array();
$Lang = Language::getSessLang();

//
// TODO Validate the values passed by $_POST. Store the errors in $error like
// $errors["field_name"] = error_description
//


$name = Validator::sanitizeString($_POST['name']);
if (strlen($name)==0) {
	$errors['name'] = Language::getSessText('UserFiles.EmtpyName');
}

if (count($errors) == 0) {
	
	$fs->setFileName($name);
	$fs->save();
	
	$url = GFUrl::getUrl();
	GFUrl::redirect($url->currentBaseURL('index.php'), array('feedback' => $Lang->getText('UserFiles.EditFeedback')));
} else {
	$feedback = implode('<br />', $errors);
	include('UserfileEdit.php');
}

?>