<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

// This code generates a SOAP API for handling FrsRelease

require_once('Validator.php');

/* ******************************************************************** */
/*                                 DATA TYPES                           */
/* ******************************************************************** */
$server->wsdl->addComplexType(
	'FrsReleaseStatus',
	'complexType',
	'struct',
	'sequence',
	'',
	array(
		'status_id' => array('name'=>'status_id', 'type' => 'xsd:int'),
		'name' => array('name'=>'name', 'type' => 'xsd:string')
	)
);


$server->wsdl->addComplexType(
	'ArrayOfFrsReleaseStatus',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(array('ref' => 'SOAP-ENC:arrayType', 'wsdl:arrayType' => 'tns:FrsReleaseStatus[]')),
	'tns:FrsReleaseStatus'
);

/* ******************************************************************** */
/*                                 METHODS                              */
/* ******************************************************************** */

$server->register(
	'getFrsReleaseStatuses',
	array(
		'sessionHash'	=> 'xsd:string'), 
	array('getFrsReleaseStatuses' => 'tns:ArrayOfFrsReleaseStatus'),
	$uri, 
	$uri.'#getFrsReleaseStatuses',
	'rpc',
	'encoded'
);


/**
 * SOAP method to retrieve the list of FrsReleaseStatuses
 */
function getFrsReleaseStatuses($sessionHash) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	$crit = new Criteria();
	$crit->add(TroveCategoryPeer::ROOT_TROVE_CATEGORY_ID, GFConf::get('system.troveDevStatus'));
	$objs = TroveCategoryPeer::doSelect($crit);
	
	$res = array();
	foreach ($objs as $obj) {
		$res[] = FrsReleaseStatusToSOAP($obj);
	}
	return $res;
}

function FrsReleaseStatusToSOAP(&$obj) {
	$ret = array();
	$ret['status_id'] = $obj->getId();
	$ret['name'] = $obj->getCategoryName();
	return $ret;
}
?>
