<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

$theme->header($params);
?>
<p>
	<a href="<?php echo GFUrl::getUrl()->projectURL($Project, '', 'admin');?>"><?php echo $Lang->getText('ProjectAdmin.title'); ?></a>
</p>
<p>
	<strong><?php echo $Lang->getText('Project.Edit'); ?></strong>
</p>
<form action="<?php echo GFUrl::getUrl()->currentBaseURL('ProjectEditAction') ?>" method="POST">
	<input type="hidden" name="id" value="<?php echo $_GET['id']; ?>" />
	<table border="0">
		<tr>
			<td><strong><?php echo $Lang->getText('Project.ProjectNameName'); ?></strong><br />
			<?php echo $project_name; ?></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Project.UnixNameName'); ?></strong><br />
			<?php echo $unix_name; ?></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Project.HomepageUrlTitle'); ?></strong><br />
			<input type="text" size="40" name="homepage_url" value="<?php echo $homepage_url; ?>" /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Project.StatusName'); ?></strong><br />
		<?php
		echo HTMLWidget::SelectBoxFromArrays(
		array(
			Project::STATUS_ACTIVE ,
			Project::STATUS_HOLDING
		),
		array(
			Language::getSessText('SiteAdmin.UserEdit.Active'),
			Language::getSessText('SiteAdmin.ProjectEdit.Holding')
		),
		'status', $status, false);?></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Project.IsTemplate'); ?></strong>
			<?php 
				if ($Project->getIsTemplate()) {
					$checked = ' checked ';
				} else {
					$checked = '';
				}
			?>
			<input type="checkbox" name="template" value="1" <?php echo $checked;?> disabled="disabled"/>
			</td>
		</tr>
		<?php if (GFConf::get('system.splitScmServers') && !is_null($ProjectScm) && $ProjectScm->getControlled()) : ?>
			<tr>
				<td><strong><?php echo $Lang->getText('ProjectScm.ScmServerIdName');?>: </strong>
		    	<?php
			    	// show the available SCM servers
			    	$c = new Criteria();
			    	$c->add(ScmServerPeer::SCM_TYPE, $repos->getType(), Criteria::ILIKE);
			    	$servers = ScmServerPeer::doSelect($c);
					if (!is_null($ProjectScm)) {
			    		$selected = $ProjectScm->getScmServerId();
			    	} else {
			    		$selected = null;
			    	}
				    	
			    	if (count($servers) == 0) {
			    		// *gasp* no SCM servers available
			    		echo $lang->getText('Scm.NoServerAvailable');
			    	} elseif (count($servers) == 1) {
			    		$server = $servers[0];
			    		echo $server->getHostname()."\n";
			    		echo '<input type="hidden" name="scm_server_id" value="'.$server->getScmServerId().'">';
			    	} elseif (count($servers) > 1) {
			    		echo HTMLWidget::select('scm_server_id', $servers, $selected, null, false);
			    	}
				?>
			</tr>

		<?php endif; ?>


<!--
		<tr>
			<td><strong><?php //echo $Lang->getText('Project.RegisterLicenseOtherName'); ?></strong><br />
			<textarea name="register_license_other" cols="50" rows="8"><?php //echo $register_license_other; ?></textarea></td>
		</tr>
-->
		<tr>
			<td><?php echo HTMLWidget::button("submit","" .   Language::getSessText('SiteAdmin.ProjectEdit.Resend') . " ","resend","","")?></td>
		</tr>
		<tr>
			<td colspan="2">
				<?php echo HTMLWidget::button("submit","" .   $Lang->getText('submit.edit') . " ","submit","","")?>
				<?php echo HTMLWidget::button("button","" .   $Lang->getText('Common.Back') . " ","cancel","","javascript:history.go(-1);")?>
					&nbsp; &nbsp; &nbsp; 
			</td>
		</tr>
<?php if (!$Project->getIsTemplate()) { ?>
		<tr>
			<td colspan="2">
			<a href="<?php echo GFUrl::getUrl()->currentBaseUrl('ProjectDelete').'&amp;id='.$_GET['id'];?>"><?php echo $Lang->getText('Project.Delete');?></a>
			</td>
		</tr>
<?php } ?>
	</table>
</form>
<?php
$theme->footer($params);
?>
