<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/scm/lib/ScmPlugin.php');
require_once('plugins/scmcvs/lib/ScmcvsPlugin.php');
require_once('plugins/scmsvn/lib/ScmsvnPlugin.php');
require_once('plugins/scmgit/lib/ScmgitPlugin.php');
require_once('html/HTMLWidget.php');

echo $theme->header($params);
?>

<p>
	<strong><?php echo $Lang->getText('ScmCommitFilter.AddNew'); ?></strong>
</p>
<form action="<?php echo GFUrl::getUrl()->currentBaseURL('ScmCommitFilterAddAction') ?>" method="POST">
	<table border="0">
		<tr>
			<td><strong><?php echo $Lang->getText('ScmCommitFilter.PluginIdName'); ?></strong><span class="required">*</span><br />
			<?php
				$c = new Criteria();
				$c->add(PluginPeer::EXCLUSIVE_TYPE, ScmPlugin::SECTION);
				// For now only CVS, SVN and git are supported 
				$criterion = $c->getNewCriterion(PluginPeer::PLUGIN_NAME, ScmcvsPlugin::getName());
				$criterion->addOr($c->getNewCriterion(PluginPeer::PLUGIN_NAME, ScmsvnPlugin::getName()));
				$criterion->addOr($c->getNewCriterion(PluginPeer::PLUGIN_NAME, ScmgitPlugin::getName()));
				$c->add($criterion);
				
				$plugins = PluginPeer::doSelect($c);
				echo HtmlWidget::select('plugin_id', $plugins, $plugin_id, 0, false);
			?>
			</td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('ScmCommitFilter.FilterDescriptionName'); ?></strong><span class="required">*</span><br />
			<input type="text" name="filter_description" value="<?php echo $filter_description; ?>"  size="40" /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('ScmCommitFilter.FilterStringName'); ?></strong><span class="required">*</span><br />
			<input type="text" name="filter_string" value="<?php echo $filter_string; ?>"  size="40" /><br />
			<?php echo $Lang->getText('ScmCommitFilter.FilterStringDescription'); ?></td>
		</tr>
		<tr>
			<td>
				<?php echo HTMLWidget::button("submit","" .   $Lang->getText('submit.add') . " ","submit","","")?>
				<?php echo HTMLWidget::button("button","" .   $Lang->getText('Common.Back') . " ","cancel","","window.location = '" .   GFUrl::getUrl()->currentBaseURL('ScmCommitFilterBrowse',array()) . "'; ")?>
			</td>
		</tr>
	</table>
</form>

<?php
echo $theme->footer($params);
?>
