<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/SiteTemplate.php');
require_once('lib/core/FilesystemPeer.php');
require_once('plugins/news/lib/News.php');

$session = Session::getSession();
$user = $session->getUser();

$template = new SiteTemplate();
$params = array(
		'selectedtoptab'	=> 'home',
		'title' => ''
	);
$template->header($params);

$url = GFUrl::getUrl();

$c = new Criteria();
$c->add(FilesystemPeer::SECTION,'frontpage'); // TODO -> this section name should be stored somewhere as a constant
$front_page = FilesystemPeer::doSelectOne($c);
$lang = Language::getSessLang();
?>
<table cellpadding="0" cellspacing="0" class='mainTable'>
	<tr>
		<td width="70%" valign="top">
<?php
if (is_object($front_page)) {
	echo '<div>';
	echo $front_page->getFileData(false);
	echo '</div>';
} else {

//default home page
?>
<p>
<h3>GForge&reg; Community Edition</h3>
</p>
<p>
GForge Community Edition is a lighter version of GForge Advanced 
Server, with a few more features than the GForge 4.x
system, and with the cleaned up interface and easy installation
of the AS platform.
</p>
<p>
GForge Community Edition has an intuitive interface that ties together a 
huge toolset, from Source Code Management (SCM) to extremely 
customizable Trackers, Task Managers, Document Managers, 
Forums. All of these are controlled by a 
centralized permission system and maintained automatically 
by the system.
</p>
<p>

</p>
<p align="center">
	<img src="/info_graphic_v2-66p.png" height="341" width="321" alt="GForge Diagram" />
</p>
<p>
<h3>Getting Started</h3>
</p>
<p>
Don't get overwhelmed by the huge toolset. Get started by 
<a href="/gf/account/?action=UserAdd">registering</a> and confirming 
your user account. Then, if needed, <a href="/gf/register/?action=ProjectAdd">register your own project.</a> 
Once your project is approved, simply visit the project and click on the 'Admin' tab.
</p>
<ul>
<li>Edit your trackers, or create new trackers, fields, and values in your fields</li>
<li>Edit your 'roles' and 'Observer' settings to set permissions and access levels</li>
<li>Add members to your project</li>
<li>Plan releases</li>
<li>Create tasks in your Task Manager</li>
<li>Start writing your code and commit code linked to your defined tasks</li>
<li>Build and release code using the File Release System</li>
<li>Log defects against the releases</li>
<li>Commit changes and link the changes to the defects</li>
<li>Start all over again!</li>
</ul>

<p>
<h3>What's the Difference?</h3>
</p>
<p>
<?php
echo $template->tableTop(array('&nbsp;','Community Edition','Advanced Server'));
$trow=array('Features',
'Fewer Features (<a href="http://gforgegroup.com/es/community-as-differences.pdf">Details</a>)',
'All Advanced Features Enabled');
echo $template->tableRow($trow);

$trow=array('Users','No limits on users or project members',
'Commercial - must purchase licenses if you exceed 15');
echo $template->tableRow($trow);

$trow=array('Download',
'<a href="http://gforgegroup.com/es/download.php">Download</a>',
'<a href="http://gforgegroup.com/es/download.php">Download</a>');
echo $template->tableRow($trow);
echo $template->tableBottom();

}
?>
<?php
	if ($session->isLoggedIn() && $user->isSiteAdmin()) {
		echo '<br />&nbsp;';
		echo '<div align="center"><p>';
		echo HTMLWidget::button("button", Language::getSessText('SiteAdmin.EditFrontPage'),"","","window.location='". GFUrl::getUrl()->baseUrl('EditFrontPage', '', 'admin')."'");
		echo '</p></div>';
	}

$theader=array(Language::getSessText('Project.News'));
$value=$template->tableTop($theader);

$c = new Criteria();
$c->setLimit(5);
$c->add(NewsPeer::IS_APPROVED,true);
$c->addDescendingOrderByColumn(NewsPeer::POST_DATE);
$news = NewsPeer::doSelectJoinProject($c);

if (count($news)) {
	foreach ($news as $new) {
		$trow=array();
		$trow[]='<strong><a href="'.$url->projectUrl($new->getProject(), 'NewsThreadView', 'news', '', array('id' => $new->getPrimaryKey())).'">'.$new->getSummary().'</a></strong><br />'.
		$new->getUser()->getUserLink().'<br />'.
		$new->getPostDate('Y-m-d') .'<p>'.
		nl2br(StringUtils::addHtmlLinks($new->getShortDetails())).'</p><br /><br /><a href="'.GFUrl::getUrl()->projectUrl($new->getProject(),'NewsThreadView','news','',array( 'id'=>$new->getNewsId())).'"><img src="/images/forum_icon.gif" alt="" border="0" height="16" width="16">&nbsp;'.Language::getSessText('News.Discussions').'</a>';
		//$new->getUser()->getUserLink() .' - '. $new->getPostDate();
		$value .= $template->tableRow($trow);
		unset($trow);
	}
} else {
	$value .= $template->tableFullRow(Language::getSessText('News.NoneFound'));
}

$value .= $template->tableBottom();

echo $value;

?>

		</td>
		<td>&nbsp;</td>
		<td valign="top" width="30%">
<?php
echo $template->infoTableTop($lang->getText('SiteHome.Activity'));
?>
<center>
<img src="/gf/graphs/?action=Activity" width="230" height="150" border="0" alt="Activity" />
</center>
<?php

echo $template->infoTableMiddle(Language::getSessText('HomePage.RecentlyRegProjects'));
//recently registered projects
$c = new Criteria();
$c->add(ProjectPeer::IS_PUBLIC, 1);
$c->add(ProjectPeer::STATUS, 1);
$c->addDescendingOrderByColumn(ProjectPeer::CREATE_DATE);
$c->setLimit(10);
$arr = ProjectPeer::doSelect($c);
if(!count($arr)) {
	echo Language::getSessText('HomePage.NoStatsAvailable');
} else {
	foreach($arr as $item) {							//todo link
		echo '<strong>('.$item->getCreateDate('Y-m-d').')</strong> <a href="'.$url->projectURL($item->getUnixName()).'">'.$item->getProjectName().'</a><br />';
	}
}
		
//top downloads
echo $template->infoTableMiddle(Language::getSessText('HomePage.TopDownloads'));

$con = Propel::getConnection(FilesystemPeer::DATABASE_NAME);
$stmt = $con->createStatement();
$sql = "select SUM(download_count) as downloads, project.project_name as project_name, project.project_id as project_id, project.unix_name as unix_name 
		from filesystem 
		left join frs_release on (filesystem.ref_id=frs_release.frs_release_id)
		left join frs_package on (frs_release.frs_package_id=frs_package.frs_package_id)
		left join project on (frs_package.project_id=project.project_id)
	where filesystem.section = 'frsrelease' and project.is_public=true 
	group by project.project_name, project.unix_name, project.project_id order by downloads desc limit 10";
$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);
if(!isset($rs)) {
	echo Language::getSessText('HomePage.NoStatsAvailable');
} else {
	while($rs->next()) {
		echo '('.number_format($rs->getInt('downloads')).') <a href="'.$url->projectURL($rs->getString('unix_name')).'">'.$rs->getString('project_name').'</a><br />';
	}
}

$params['template'] = $template;
$prs = ActionManager::notify('BUILD_FRONTPAGE_ELEMENTS',$params);
foreach ($prs as $pr) {
	echo	$pr->getResult();
}

//browse by topic box
echo $template->infoTableMiddle(Language::getSessText('HomePage.BrowseTopic'));

$con = Propel::getConnection(FilesystemPeer::DATABASE_NAME);
$stmt = $con->createStatement();

$sql="select * from trove_category tc natural join trove_link_count where tc.parent_trove_category_id=".GFConf::get('system.troveTopic')." AND section='project'";
$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);
if(!isset($rs)) {
	echo Language::getSessText('Project.NoneFound');
} else {
	while($rs->next()) {
		echo '<a href="/gf/project/?action=ProjectTroveBrowse&_trove_category_id='.$rs->getInt('trove_category_id').'">'.$rs->getString('category_name').' ('.$rs->getInt('link_count').')</a><br />';
	}
}

//Support and docs box
echo $template->infoTableMiddle($lang->getText('SiteHome.SupportDocs'));
echo '<a href="/gf/project/support/">Local Support Project</a>';
echo '<p><a href="http://gforge.org/projects/as-help">GForge Help Forum &amp; Docs</a><br />';
echo '<a href="https://gforge.com/gf/project/office-addin/">Office Add-in Project</a><br />';
echo '<a href="https://gforge.com/gf/project/soapsdk/">SOAP SDK Project</a><br />';
echo '</p><strong>Commercial Plugins</strong><p>';
echo '<a href="https://gforge.com/gf/project/eclipse/">Eclipse Project</a><br />';
echo '<a href="https://gforge.com/gf/project/msproject/">MS Project Plugin</a><br />';
echo '<a href="https://gforge.com/gf/project/vsplugin/">Visual Studio Plugin</a><br />';
echo '</p>';

echo $template->infoTableBottom();
?>
		</td>
	</tr>
</table>
<?php
$template->footer();
?>
