<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Julian Yerfino jyerfino@gforgegroup.com
 * @date
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/MyTemplate.php');
require_once('lib/core/FilesystemPeer.php');
//require_once('lib/core/UserProjectPeer.php');
require_once('lib/html/HTMLWidget.php');
require_once('lib/core/MyReport.php');
require_once('lib/core/MyReportPeer.php');
require_once('lib/core/MyReportProject.php');
require_once('lib/core/MyReportProjectPeer.php');

$session=Session::getSession();
if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();
}
$template = new MyTemplate();
$user = Session::getSession()->getUser();

if(isset($_REQUEST['feedback'])) $feedback = $_REQUEST['feedback'];
if(isset($_REQUEST['report_id'])) {
	$report_id = Validator::sanitizeInt($_REQUEST['report_id']);
	// Fetch report data
	if($report_id != 0) {
		$report = MyReportPeer::retrieveByPK($report_id);
		if(!is_object($report)) {
			throw new InvalidDataException();
		}
	}
	else {
		throw new InvalidDataException();
	}
}
else {
	throw new InvalidDataException();
}

if($report->getUserId() != $user->getUserId()) {
	$parms = array ('feedback'=>$Lang->getText('Report.NotOwner'));
	GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL(''), $parms);
	exit();
}

$params = array(
	'title' => Language::getSessText('Report.Delete'),
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	'action' => isset($action) ? $action : '',
	'selectedbottomtab' => 'myreports',
	'user' => $user
	);
$template->header($params);

$params['theme'] = $template;
$Lang = $session->getLanguage();

include('forms/ReportDelete-tpl.php');

$template->footer();
?>
