<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new ProjectJoinRequest and saves it to the 
// database
//
require_once('core/ProjectJoinRequest.php');
require_once('Validator.php');
require_once('exceptions/InvalidDataException.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}
if (!Session::getSession()->isLoggedIn()) {
	throw new PermissionDeniedException();
}

$project = GFUrl::getUrl()->getProject();
$user_id = Session::getSession()->getUser()->getUserId();


$crit = new Criteria();
$crit->add(UserProjectPeer::PROJECT_ID, $project->getProjectId());
$crit->add(UserProjectPeer::USER_ID, $user_id);
$oMember = UserProjectPeer::doSelectOne($crit);


$Lang = Language::getSessLang();


if (is_object($oMember)) {
	GFUrl::redirect(GFUrl::getUrl()->currentBaseURL(''), array('feedback' => $Lang->getText('ProjectJoinRequestException.AlreadyMember')));
}


$ProjectJoinRequest = new ProjectJoinRequest();


try {
	$crit = new Criteria();
	$crit->add(ProjectJoinRequestPeer::PROJECT_ID,$project->getProjectId());
	$crit->add(ProjectJoinRequestPeer::USER_ID,Session::getSession()->getUser()->getUserId());
	$pjr = ProjectJoinRequestPeer::doSelectOne($crit);
	if (is_object($pjr)) {
	} else {

		$ProjectJoinRequest->setProjectId($project->getProjectId());
		$ProjectJoinRequest->setUserId(Session::getSession()->getUser()->getUserId());
		$ProjectJoinRequest->setComments( Validator::sanitizeString($_POST['comments']) );

		$ProjectJoinRequest->save();
	}
	GFUrl::redirect(GFUrl::getUrl()->currentBaseURL(''), array('feedback' => $Lang->getText('ProjectJoinRequest.AddFeedback')));
} catch (InvalidDataException $ex) {
	$errors = array_merge($errors, $ex->getErrors());		// attach object errors to validation errors
	$feedback = '* '.implode('<br>* ', $errors);
	include('ProjectJoinRequestAdd.php');

}
?>
